program test1;
{$mode objfpc}{$H+}
uses Classes, SysUtils, DateUtils, StrUtils, XMLParser;

(* 
  Testing the speed of MYTHcode <http://mythcode.org> XML Parser

  Compile with: fpc -Fumythcode test1.pas

*)

type
  PPerson = ^TPerson;
  TPerson = record
    FirstName: String;
    SurName: String;
    Age: Byte;
  end;

procedure main;
var
  people: TList;
  xml: TStrings;
  parser: TXMLParser;
  starttime, endtime: TDateTime;
  person: PPerson;
  runtime: String;
begin
  people := TList.Create;
  xml := TStringList.Create;
  xml.LoadFromFile('namelist.xml');
  starttime := Now;
  parser := TXMLParser.Create(xml.Text);
  while parser.Next do
  begin
    if Parser.TagType = ttBeginTag then
    begin
      if Parser.Name = 'person' then new(person);
      if Parser.Name = 'firstname' then person^.FirstName := parser.ContentCode;
      if Parser.Name = 'surname' then person^.SurName := parser.ContentCode;
      if Parser.Name = 'age' then person^.Age := StrToIntDef(parser.ContentCode,0);
    end;
    if (Parser.TagType = ttEndTag) and (Parser.Name = 'person') then
    begin
      people.Add(person);
    end;
  end;
  endtime := Now;
  xml.Free;
  parser.Free;
  writeln(people.Count,' people found');
  DateTimeToString(runtime,'HH:nn:ss.zzz',(endtime-starttime));
  writeln('Completed in ',runtime);
  people.Free;
end;

begin
  main;
end.