program test2;
{$mode objfpc}{$H+}
uses Classes, SysUtils, DateUtils, StrUtils, LibXmlParser;

(*
  Testing the speed of LibXmlParser <http://www.destructor.de> XML Parser
  (non-Unicode version)

  Compile with: fpc test2.pas

*)

type
  TCurrentTagType = (ttNone, ttFirstName, ttSurName, ttAge);
  PPerson = ^TPerson;
  TPerson = record
    FirstName: String;
    SurName: String;
    Age: Byte;
  end;

procedure main;
var
  people: TList;
  parser: TXMLParser;
  starttime, endtime: TDateTime;
  person: PPerson;
  runtime: String;
  currentTag: TCurrentTagType;
begin
  people := TList.Create;
  starttime := Now;
  parser := TXMLParser.Create;
  parser.Normalize := true;
  parser.LoadFromFile('namelist.xml');
  parser.StartScan;
  while parser.Scan do
  begin
    if Parser.CurPartType = ptStartTag then
    begin
      currentTag := ttNone;
      if Parser.CurName = 'person' then new(person);
      if Parser.CurName = 'firstname' then currentTag := ttFirstName;
      if Parser.CurName = 'surname' then currentTag := ttSurName;
      if Parser.CurName = 'age' then currentTag := ttAge;
    end;
    if Parser.CurPartType = ptContent then
    begin
      case currentTag of
        ttFirstName: person^.FirstName := parser.CurContent;
        ttSurName: person^.SurName := parser.CurContent;
        ttAge: person^.Age := StrToIntDef(parser.CurContent,0);
      end;
    end;
    if (Parser.CurPartType = ptEndTag) and (Parser.CurName = 'person') then
    begin
      people.Add(person);
    end;
  end;
  endtime := Now;
  parser.Free;
  writeln(people.Count,' people found');
  DateTimeToString(runtime,'HH:nn:ss.zzz',(endtime-starttime));
  writeln('Completed in ',runtime);
  people.Free;
end;

begin
  main;
end.